#!/bin/sh

# Common functions used by other scripts
# $Header: /usr/local/cvsroot/panaos/admin/cgi-bin/common/common.sh,v 1.9 2007/12/01 14:15:06 maosy Exp $
# ChangeLogs:
# (1)2004/11/11: softmic created the file
#

. /etc/PG.conf
PGBIN=${PGPATH}/bin
FLOWEYE=${PGBIN}/floweye
EVENTFILE=${PGETC}/log/pending_events

# root directory of configuration files

# show message
# @param arg1 msg
# @param arg2 return url
# @param arg3 id
# @param arg4 task
# @return
afm_show_msg()
{
    echo "<html><body><center><br><br><br><br><br><br><table>"
    echo "<form action=\"$2\">"
    echo "<tr><td><h5>$1</h5></td></tr>"
    echo "<tr><td align=center>"
    echo "<input type=hidden name=\"id\" value=\"$3\">"
    echo "<input type=hidden name=\"task\" value=\"$4\">"
    echo "<input type=submit value=\"ȷ\"></td></tr>"
    echo "</form>"
    echo "</table></center>"
    echo "</body></html>"
}

afm_alert_msg()
{
	echo "<script language=javascript>
alert(\"$1\");
location.href=\"$2\";
</script>"
}

afm_alert_msgx()
{
	echo "<script language=javascript>
alert(\"$1\");
open(\"javascript:history.go(-1)\", \"_self\");
</script>"
}

afm_dialog_close()
{
	echo "<script language=javascript>"
	if [ "$2" != "" ]; then
		echo "alert(\"$2\");"
	fi
	echo "window.returnValue = \"$1\";"
	echo "window.close();"
	echo "</script>"
}

afm_dialog_msg()
{
    echo "<script language=javascript>"
    echo "alert(\"$1\");"
    echo "</script>"
}

# print html header
# @param arg1 active tap caption
# NOTES: MOD_CAPTION and MOD_TAB_LIST are defined in
#        each module
afm_print_mod_header()
{
	local capurl=""
	local cap=""
	local url=""
	local width="$2"

	[ "${width}" = "" ] && width="76%"	

	echo "<table width=\"${width}\" border=0 cellspacing=0 cellpadding=0><tr>"
	for capurl in ${MOD_TAB_LIST}
	do
		cap=`echo ${capurl} | cut -d'#' -f1`
		url=`echo ${capurl} | cut -d'#' -f2`
		if [ "${cap}" = "$1" ]; then
			echo "<td width=110 height=23 background=\"/img/bg1.gif\" style=\"padding-top:4px\">&nbsp;&nbsp;
<strong><span style=\"color:#ffffff;font-family:Arial\">${cap}</span></strong></td>"
		else
			echo "<td width=110 background=\"/img/bg2.gif\" style=\"padding-top:4px\">&nbsp;&nbsp;
<a href=\"/cgi-bin/${url}\"><span style=\"font-family:Arial\">${cap}</span></a></td>"
		fi
		echo "<td width=1></td>"
	done
    echo "<td width=\"*\">&nbsp;</td>"

	echo "</tr><tr><td colspan=9 height=1 bgcolor=\"#03688B\"></td></tr><tr><td colspan=6 height=10></td></tr></table>"
}


cgi_print_mod_header()
{
	local capurl=""
	local cap=""
	local url=""
	local width="$2"

	[ "${width}" = "" ] && width="76%"
	echo "<table width=\"${width}\" border=0 cellspacing=0 cellpadding=0><tr>"
	for capurl in ${MOD_TAB_LIST}
	do
		cap=`echo ${capurl} | cut -d'#' -f1`
		url=`echo ${capurl} | cut -d'#' -f2`
		if [ "${cap}" = "$1" ]; then
			echo "<td width=10><img src=\"/img/page1.gif\" width=10 height=23></td>
<td width=72 bgcolor=\"#135AC1\" style=\"font:bold 14px; color:#ffffff; padding:2px 0px\">${cap}</td>
<td width=25><img src=\"/img/page23.gif\" width=25 height=23></td>"
		else
			echo "<td width=10><img src=\"/img/page21.gif\" width=10 height=23></td>
<td width=72 bgcolor=\"#ffffff\" style=\"font:bold 14px; color:#135AC1; padding:2px 0px; border-top:1px solid #135AC1; border-bottom:1px solid #135AC1\"><a style=\"color:#135AC1;text-decoration:none;font:bold 14px\" href=\"${url}\">${cap}</a></td><td width=25><img src=\"/img/page3.gif\" width=25 height=23></td>"
		fi
	done

	echo "<td width=\"*\" style=\"border-bottom:1px solid #135AC1\">&nbsp;</td>"
	echo "</tr></table>"
}

# arg1: page caption
# arg2: page id
# arg3: is visible
# arg4: width
AFM_BEGIN_PAGE()
{
    local capurl=""
    local cap=""
    local url=""

	if [ "$3" = "true" -o "$3" = "TRUE" ]; then
		echo "<div id=\"$2\" style=\"display:block\">"
	else
		echo "<div id=\"$2\" style=\"display:none\">"
	fi

    echo "<table width=\"96%\" border=0 cellspacing=0 cellpadding=0><tr>"
    for capurl in ${AFM_PAGE_LIST}
    do
        cap=`echo ${capurl} | cut -d'#' -f1`
        url=`echo ${capurl} | cut -d'#' -f2`
        if [ "${cap}" = "$1" ]; then
            echo "<td width=110 height=20 background=\"/img/bg1.gif\" style=\"padding-top:4px\">&nbsp;&nbsp;&nbsp;
<strong><span style=\"color:#ffffff;font-family:Arial\">${cap}</span></strong></td>"
        else
            echo "<td width=110 background=\"/img/bg2.gif\" style=\"padding-top:4px\">&nbsp;&nbsp;&nbsp;
<a href=\"${url}\"><span style=\"font-family:Arial\">${cap}</span></a></td>"
        fi
        echo "<td width=1></td>"
    done
    echo "<td width=\"*\">&nbsp;</td>"
    echo "</tr>"
    echo "</table>"
#    echo "<tr><td colspan=9 height=1 bgcolor=\"#03688B\"></td></tr></table>"
}

AFM_END_PAGE()
{
	echo "</div>"
}

# redirect current page to the designated page
# @param arg1 time to wait
# @param arg2 url of the designated page
# @return 
afm_load_page()
{
    echo "<META HTTP-EQUIV=REFRESH CONTENT=\"$1;URL=$2\">"
}

# to see if arg1 is digit number
# @param arg1
# @return 1(yes), 0(no)
afm_isdigit()
{
	local ret=""

	ret=`echo $1 | sed -e "s/[0-9]//g"`
	[ "${ret}" = "" -o "${ret}" = "-" ] && return 1
	return 0
}

# @param arg1 the number
# @param arg2 begin number
# @param arg3 end number
# @return 1(yes) 0(no)
afm_isbetween()
{
	local ret=""

	ret=`echo $1 | sed -e "s/[0-9]//g"`
	[ "${ret}" != "" -a "${ret}" != "-" ] && return 0
	
	[ $1 -ge $2 -a $1 -le $3 ] && return 1
	return 0
}

# to see if arg1 is an IP address
# @param arg1
# @return 1(yes), 0(no)
afm_isipaddr()
{
	local v=""

	v=`echo $1 | cut -d'.' -f1`
	afm_isbetween "$v" 0 255
	[ "$?" = "0" ] && return 0

	v=`echo $1 | cut -d'.' -f2`
	afm_isbetween "$v" 0 255
	[ "$?" = "0" ] && return 0

	v=`echo $1 | cut -d'.' -f3`
	afm_isbetween "$v" 0 255
	[ "$?" = "0" ] && return 0

	v=`echo $1 | cut -d'.' -f4`
	afm_isbetween "$v" 0 255
	[ "$?" = "0" ] && return 0

	v=`echo $1 | cut -d'.' -f5`
	[ "$v" != "" ] && return 0

	return 1 
}

afm_show_caption()
{
	local height=20

	[ "$2" != "" ] && height=$2
	echo "<table width=\"76%\" border=0 cellspacing=0 cellpadding=3><tr><td height=${height} class=bgurl>$1</td></tr></table>"
}

show_caption2()
{
	local height=20

	[ "$2" != "" ] && height=$2
	echo "<table width=\"76%\" border=0 cellspacing=0 cellpadding=3><tr><td height=${height} class=cssTDArial>$1</td></tr></table>"
}

# arg1: url prifix
# arg2: total count
# arg3: current page no
afm_show_navigator()
{
	local next_page=0
	local prev_page=0
	local total=0
	local total_page=0
	local url_prefix=$1
	local curpage=$3

	echo "<table width=\"96%\" border=0 cellspacing=0 cellpadding=0>"
	echo "<tr>"

	[ "${curpage}" = "" ] && curpage=1
	next_page=`expr ${curpage} + 1`
	prev_page=`expr ${curpage} - 1`
	total=$2
	[ "${PAGE_ROW}" = "" ] && PAGE_ROW=20
	[ ${PAGE_ROW} -le 0 ] && PAGE_ROW=20

	total_page=`expr ${total} / ${PAGE_ROW}`
	if [ "`expr ${total_page} % ${PAGE_ROW}`" != "0" ]; then
    	total_page=`expr ${total_page} + 1`
	fi

	echo "<td height=20 align=right bgcolor=\"#a0a0a0\" style=\"padding-right:15px\">"

	if [ ${curpage} -eq 1 ]; then
    	echo "<font color=\"#ffffff\">ҳ</font>&nbsp;&nbsp;"
	else
    	echo "<a href=\"${url_prefix}&page=1\"><font color=\"#ffffff\">ҳ</font></a>&nbsp;&nbsp;"
	fi

	if [ ${curpage} -gt 1 -o ${curpage} -eq -1 ]; then
    	echo "<a href=\"${url_prefix}&page=${prev_page}\"><font color=\"#ffffff\">һҳ</font></a>&nbsp;&nbsp;"
	else
    	echo "<font color=\"#ffffff\">һҳ</font>&nbsp;&nbsp;"
	fi

	if [ ${curpage} -lt ${total_page} -a ${curpage} -ne -1 ]; then
    	echo "<a href=\"${url_prefix}&page=${next_page}\"><font color=\"#ffffff\">һҳ</font></a>&nbsp;&nbsp;"
		echo "<a href=\"${url_prefix}&page=-1\"><font color=\"#ffffff\">βҳ</font></a>"
	else
    	echo "<font color=\"#ffffff\">һҳ</font>&nbsp;&nbsp;"
		echo "<font color=\"#ffffff\">βҳ</font>"
	fi

	echo "</td>"
	echo "</tr></table>"
}

# arg1: source file
# arg2: page no
# arg3: dst file
afm_locate_page()
{
	local curpage=$2
	local srcfile=$1
	local dstfile=$3
	local begin_no=1
	local total=0

	[ "${curpage}" = "" ] && curpage=1
	[ "${PAGE_ROW}" = "" ] && PAGE_ROW=20
	if [ ${curpage} -lt 0 ]; then
		total=`cat ${srcfile} | wc -l`
		curpage=`expr ${total} / ${PAGE_ROW}`
	fi

	begin_no=`expr ${curpage} \* ${PAGE_ROW}`
	cat ${srcfile} | head -n ${begin_no} | tail -n ${PAGE_ROW} > ${dstfile}
}

# print all services into stdout, each line is for
# one service
# @param $1 type of the service, 'user' or 'sys', maybe null
afm_print_services()
{
	local tmp1=""
	local tmp2=""
	local name=""
	local attr=""
	local value=""
	local tmpfile=/tmp/servicelist.tmp$$

	${AFMADMIN} listobject type=service | while read tmp1 tmp2 name
	do
		${AFMADMIN} getobject type=service name="${name}" > ${tmpfile}
		while read attr value
		do
			eval "${attr}=${value}"
		done < ${tmpfile}

		[ "${svcid}" = "" ] && continue
		[ "${proto}" = "" ] && continue
		[ "${svctype}" = "" ] && svctype="user"
		[ "${rateclass}" = "" ] && rateclass=0

		if [ "$1" = "" -o "$1" = "${svctype}" ]; then
			echo "${name} ${svcid} ${proto} ${dport} ${rateclass}"
		fi
		dport=""  # dport maybe empty, eg. IPSec
	done

	[ -f ${tmpfile} ] && ${CMD_RM} -f ${tmpfile}
}

show_caption()
{
        echo "<table width=\"76%\" border=0 cellspacing=1 cellpadding=1 bgcolor=\"#ffffff\">"
        echo "<tr height=24><td class=bgurl2 align=left>$1</td></tr>"
        echo "</table>"
}

afm_show_proto()
{
	if [ -f ${P2PCFGDIR}/proto_sys.conf ]; then
		exec 0<${P2PCFGDIR}/proto_sys.conf
		while read pid a1 a2 a3 a4 pname
		do
			echo "<option value=${pid}>${pname}</option>"
		done
	fi

	if [ -f ${P2PCFGDIR}/proto_usr.conf ]; then
		exec 0<${P2PCFGDIR}/proto_usr.conf
		while read pid a1 a2 a3 a4 pname
		do
			echo "<option value=${pid}>${pname}</option>"
		done
	fi
}

afm_show_group()
{
	if [ -f ${P2PCFGDIR}/proto_group.conf ]; then
		exec 0<${P2PCFGDIR}/proto_group.conf
		while read gid gname
		do
			if [ "${gid}" = "unknown" ]; then
				continue
			fi

			echo "<option value=${gid}>${gname}</option>"
		done
	fi
}

afm_show_ifname()
{
	${IPFW} if show | awk '{print $1}' | \
	while read ifname
	do
		if [ "${ifname}" != "If-name" ]; then
			echo "<option value=${ifname}>${ifname}</option>"
		fi
	done
}

afm_get_grpname()
{
	cat ${P2PCFGDIR}/proto_group.conf | grep "^$1" | cut -d' ' -f2
}

cgi_show_title()
{
	curtime=`date +%s`
	boottime=`sysctl -n kern.boottime | cut -d',' -f1 | cut -d'=' -f2`
	boottime=`expr ${curtime} - ${boottime}`
	bootday=`expr ${boottime} / 86400`
	dayhour=`expr ${bootday} \* 24`
	boothour=`expr ${boottime} / 3600`
	boothour=`expr ${boothour} - ${dayhour}`
	bootsec=`expr ${boottime} % 3600`
	bootmin=`expr ${bootsec} / 60`
	bootsec=`expr ${boottime} % 60`

	echo "<table class=title>"
	echo "<tr><td><b>$1</b></td><td style=\"font:12px;color:#0000ff\" align=right width=*>ϵͳ${bootday}${boothour}Сʱ${bootmin}${bootsec}"
	if [ -f ${DATAPATH}/panaos.core ]; then
		echo "(ϵͳcrash)"
	else
		echo "(ϵͳ)"
	fi
	echo "</td></tr></table>"
}

#
# arg1: title
# arg2: other urls, format is the same as MOD_TAB_LIST
cgi_show_title2()
{
	local capurl
	local cap
	local url

	echo "<table style=\"width:700; border-bottom:1px #787882 solid; font:bold  14px; color:#0000ff\">
<tr><td><b>$1</b></td><td align=right>"

	for capurl in $2; do
		[ "${capurl}" = "" ] && break
		cap=`echo ${capurl} | cut -d'#' -f1`
		url=`echo ${capurl} | cut -d'#' -f2`
		echo "&nbsp;&nbsp;&nbsp;<a style=\"color:#0000ff;\" href=\"${url}\">${cap}</a>"
	done

	echo "</td></tr></table>"
}

cgi_list_intf()
{

	echo "<table width=700 border=0 cellspacing=1 cellpadding=1 bgcolor=\"#ffffff\">
<tr height=22>
	<td width=125 class=bgurl2 align=center><b>ӿ</b></td>
	<td width=150 class=bgurl2 align=center><B>Ӧģʽ</B></td>
	<td width=150 class=bgurl2 align=center><B>λ</B></td>
	<td width=125 class=bgurl2 align=center><B></b></td>
	<td width=150 class=bgurl2 align=center><B>·״̬</b></td>
</tr>
<tr height=2><td width=*></td></tr>"


	class="cssTDWhite"
	${FLOWEYE} if list2 | \
	while read ifname ifzone ifmode ifpeer ifstatus ifdriver theothers
	do
		[ "${ifname}" = "name" ] && continue
		echo "<tr height=24><td class=${class} align=center><a style=\"color:#0000ff\" href=\"/cgi-bin/Monitor/$1?ifname=${ifname}\"><b>${ifname}</b></td>"
 
		# Show interface mode
		if [ "${ifpeer}" = "none" ]; then
        		echo "<td class=${class} align=center>ģʽ</td>"
		else
			echo "<td class=${class} align=center>-->${ifpeer}</td>"
		fi
 
		# Show interface zone
		if [ "${ifzone}" = "inside" ]; then
        		echo "<td class=${class} align=center></td>"
		elif [ "${ifzone}" = "outside" ]; then
        		echo "<td class=${class} align=center></td>"
		else
			echo "<td class=${class} align=center>${ifzone}</td>"
		fi
 
		# Show driver
		[ "${ifdriver}" = "PANAOS" ] && ifdriver="ǿ"
		echo "<td class=${class} align=center><b>${ifdriver}</b></td>"

		# Show NIC status
		if [ "${ifstatus}" = "up" ]; then
			echo "<td class=${class} align=center style=\"color:#0000ff\"></td>"
		else
			echo "<td class=${class} align=center style=\"color:#ff0000\">ûнӵ</td>"
		fi

		echo "</tr>"

		if [ "${class}" = "cssTDWhite" ]; then
			class="cssTDGray"
		else
			class="cssTDWhite"
		fi
	done
	echo "</table>"

	return 0
}

#
# Create template rdf for interface
# cgi_ifrdf_create ifname width height
#
cgi_ifrdf_create()
{
	local ifname
	local width
	local height
	local rdfile

	ifname=$1
	width=$2
	height=$3
	[ "${width}" = "" ] && width=570
	[ "${height}" = "" ] && height=300

	# Create BPS rdf
	rdfile=${PGPATH}/rdf/${ifname}_bps.rdf
	if [ ! -f ${rdfile} ]; then
        	echo "width=${width}
height=${height}
AREA=udp,ifbi,ff0000,if_${ifname}
STACK=tcp,ifbi,00ff00,if_${ifname}
STACK=udp,ifbo,0000ff,if_${ifname}
STACK=tcp,ifbo,ffff00,if_${ifname}
LINE2=total,ifbi,000000,if_${ifname}
STACK=total,ifbo,ff00ff,if_${ifname}" > ${rdfile}
	fi

	# Create PPS rdf
	rdfile=${PGPATH}/rdf/${ifname}_pps.rdf
	if [ ! -f ${rdfile} ]; then
        	echo "width=${width}
height=${height}
unit=packets/s
AREA=udp,ifpi,ff0000,if_${ifname}
STACK=tcp,ifpi,00ff00,if_${ifname}
STACK=udp,ifpo,0000ff,if_${ifname}
STACK=tcp,ifpo,ffff00,if_${ifname}
LINE2=total,ifpi,000000,if_${ifname}
STACK=total,ifpo,ff00ff,if_${ifname}" > ${rdfile}
	fi

	# Create SYN rdf
	rdfile=${PGPATH}/rdf/${ifname}_syn.rdf
	if [ ! -f ${rdfile} ]; then
        	echo "width=${width}
height=${height}
unit=packets/s
AREA=syn,ifpi,00ff00,if_${ifname}" > ${rdfile}
	fi

	return 0
}

#
# Create template rdf file for application
# Usage: ipe_rdfgen app [width] [height]
cgi_apprdf_create()
{
	local width
	local height

	width=$2
	height=$3
	[ "${width}" = "" ] && width=570
	[ "${height}" = "" ] && height=220

	if [ ! -f ${PGPATH}/rdf/bps_$1.rdf ]; then
		echo "width=${width}
height=${height}
unit=bps/s
rrdfile=app_local.rrd
AREA=$1,appbu,00ff00
LINE2=$1,appbd,0000ff" > ${PGPATH}/rdf/bps_$1.rdf
	fi

	if [ ! -f ${PGPATH}/rdf/flow_$1.rdf ]; then
		echo "width=${width}
height=${height}
unit=flow count
rrdfile=app_local.rrd
AREA=$1,appflow,00ff00" > ${PGPATH}/rdf/flow_$1.rdf
	fi

	if [ ! -f ${PGPATH}/rdf/node_$1.rdf ]; then
		echo "width=${width}
height=${height}
unit=node count
rrdfile=app_local.rrd
AREA=$1,appnode,00ff00" > ${PGPATH}/rdf/node_$1.rdf
	fi
}

cgi_calctime()
{
        local hour=$1
        local min=$2
        local total=$3

        hour=`expr ${hour} \* 3600`
        min=`expr ${min} \* 60`
        total=`expr ${total} + ${min}`
        total=`expr ${total} + ${hour}`

        echo "${total}"
}


#
# Show application select dropdown box's options.
#
html_show_app_noany()
{
	local type
	local apid
	local apname
	local curapid=$1

	${FLOWEYE} app list menu | while read type apid apname
	do
		selected=""
		[ "${curapid}" = "${apid}" ] && selected="selected"

		if [ "${type}" = "GROUP" ]; then
			echo "<option value=\"${apid}\" ${selected}>${apname}</option>"
		elif [ "${type}" = "APP" ]; then
			echo "<option value=\"${apid}\" ${selected}>---${apname}</option>"
		fi
	done

	if [ "${curapid}" = "default" ]; then
		echo "<option value=default selected>δ֪Э</option>"
	else
		echo "<option value=default>δ֪Э</option>"
	fi

}

#
# Show application select dropdown box's options.
#
html_show_app()
{
	local type
	local apid
	local apname
	local curapid=$1

	if [ "${curapid}" = "any" ]; then
		echo "<option value=any selected>Э</option>"
	else
		echo "<option value=any>Э</option>"
	fi

	html_show_app_noany $1
}

#
# Show interface select dropdown box's options
#
html_show_intf()
{
	local curif=$1
	local ifname

	for ifname in `${FLOWEYE} if list | awk '{print $1}'`
	do
		if [ "${ifname}" != "name" ]; then
			selected=""
			[ "${ifname}" = "${curif}" ] && selected="selected"
			echo "<option value=\"${ifname}\" ${selected}>${ifname}</option>"
		fi
	done	
}


# Convert x.x.x.x to an integer
cgi_ip2int()
{
	local x1
	local x2
	local x3
	local x4
	local x

	x1=`echo $1 | cut -d'.' -f1`
	x2=`echo $1 | cut -d'.' -f2`
	x3=`echo $1 | cut -d'.' -f3`
	x4=`echo $1 | cut -d'.' -f4`

	x1=`expr ${x1} \* 16777216`
	x2=`expr ${x2} \* 65536`
	x3=`expr ${x3} \* 256`
	x=`expr ${x1} + ${x2}`
	x=`expr $x + ${x3}`
	x=`expr $x + ${x4}`

	echo "$x" 
}

# Show application or group's static
# arg1: active page caption
# arg2: application or group id
# arg3: stat type (bps, flow, node)
cgi_show_appstat()
{
	local daypng
	local weekpng
	local monthpng
	local rdfpath
	local errmsg
	local caption="$1"
	local appid="$2"
	local type="$3"

	if [ "${type}" != "bps" -a "${type}" != "flow" -a \
	     "${type}" != "node" ]; then
		afm_dialog_msg "Invalid arguments"
		return 1
	fi

	daypng="${PGPATH}/admin/img/${appid}_day.png"
	weekpng="${PGPATH}/admin/img/${appid}_week.png"
	monthpng="${PGPATH}/admin/img/${appid}_month.png"

	# Create rdf for the application if it doesn't exist!
	cgi_apprdf_create ${appid}
	rdfpath=${PGPATH}/rdf/${type}_${appid}.rdf

	# Create the report
	errmsg=`${FLOWEYE} rrd graph -d -r ${PGPATH}/rrd -i ${rdfpath} -o ${daypng}`
	errmsg=`${FLOWEYE} rrd graph -w -r ${PGPATH}/rrd -i ${rdfpath} -o ${weekpng}`
	# errmsg=`${FLOWEYE} rrd graph -m -r ${PGPATH}/rrd -i ${rdfpath} -o ${monthpng}`

	cgi_print_mod_header ${caption} 700

	echo "<table width=700 border=0 cellspacing=1 cellpadding=1 bgcolor=\"#ffffff\"><tr>
<td width=100 align=left style=\"font-size:12px;font-weight:bold;\">ʱ</td>
<td align=left style=\"font-size:13px\">`date \"+%Y-%m-%d %H:%M:%S\"`</td> </tr> </table>"

	echo "<p><b>һͼ</b></p>
<table width=700 border=0 cellspacing=1 cellpadding=1 bgcolor=\"#ffffff\">
<tr><td width=30>&nbsp;</td><td><img src=\"/img/${appid}_day.png\"></img></td></tr></table>"

	echo "<p><b>һͼ</b></p>
<table width=700 border=0 cellspacing=1 cellpadding=1 bgcolor=\"#ffffff\">
<tr><td width=30>&nbsp;</td><td><img src=\"/img/${appid}_week.png\"></img></td></tr></table>"

	#echo "<p><b>һͼ</b></p>
#<table width=700 border=0 cellspacing=1 cellpadding=1 bgcolor=\"#ffffff\">
#<tr><td width=30>&nbsp;</td><td><img src=\"/img/${appid}_month.png\"></img></td></tr></table>"

	return 0
}


# Set dirty flag of a group
# arg: polgrpid
cgi_set_polgrp_dirty()
{
	touch /tmp/polgrp_$1_dirty
}

cgi_is_polgrp_dirty()
{
	if [ -f /tmp/polgrp_$1_dirty ]; then
		echo "yes"
	else
		echo "no"
	fi
}

# show policy actions
# args: polgrpid action dir
html_show_policy_action()
{
	local polgrpid=$1
	local action="$2"
	local dir="$3"

	if [ "${action}" = "permit" ]; then
		echo "<option value=permit selected></option>"
	else
		echo "<option value=permit></option>"
	fi

	if [ "${action}" = "deny" ]; then
		echo "<option value=deny selected></option>"
	else
		echo "<option value=deny></option>"
	fi

	cat ${PGETC}/polgrp_${polgrpid}.conf | \
	while read objtype pno pname ptype pdir prate
	do
		[ "${objtype}" != "pipe" ] && continue
		[ "${pdir}" != "both" -a "${pdir}" != "${dir}" ] && continue

		if [ "${action}" = "pipe:${pno}" ]; then
			echo "<option value=\"pipe:${pno}\" selected>${pname}</option>"
		else
			echo "<option value=\"pipe:${pno}\">${pname}</option>"
		fi
	done
}

#
# Create the directory as necessary.
#
[ ! -d ${PGETC}/network ] && mkdir ${PGETC}/network
[ ! -d ${PGETC}/shape ] && mkdir ${PGETC}/shape

#
# Show CGI header
#
echo "<html xmlns:v=\"urn:schemas-microsoft-com:vml\" xmlns:o=\"urn:schemas-microsoft-com:office:office\">
<head><title></title>
<link href=\"/img/p2p.css\" type=\"text/css\" rel=\"stylesheet\">
<meta http-equiv=\"Content-Type\" content=\"text/html; charset=gb2312\">
<META HTTP-EQUIV=\"Pragma\" CONTENT=\"no-cache\">
<META HTTP-EQUIV=\"Cache-Control\" content=\"no-cache\">
</head>"
